-- LeifDecisions
-- Author: TheMH06
-- DateCreated: 4/19/2018 8:51:13 PM
--------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------------------
-- Velthomer: Send the Rottenritter out and make some BBQ
--------------------------------------------------------------------------------------------------------------------------
local Decisions_ArvisRottenritter = {}
	Decisions_ArvisRottenritter.Name = "TXT_KEY_DECISIONS_ARVIS_ROTTENRITTER"
	Decisions_ArvisRottenritter.Desc = "TXT_KEY_DECISIONS_ARVIS_ROTTENRITTER_DESC"
	HookDecisionCivilizationIcon(Decisions_ArvisRottenritter, "CIVILIZATION_MH_VELTHOMER")
	Decisions_ArvisRottenritter.CanFunc = (
	function(pPlayer)
		if pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_MH_VELTHOMER then return false, false end
		if load(pPlayer, "Decisions_ArvisRottenritter") == true then
			Decisions_ArvisRottenritter.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_ARVIS_ROTTENRITTER_ENACTED_DESC")
			return false, false, true
		end
		--local iReward = math.ceil(300*iMod)
		Decisions_ArvisRottenritter.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_ARVIS_ROTTENRITTER_DESC")
		if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 3) then return true, false end
		if pPlayer:GetNumPolicyBranchesFinished() < 2 then return true, false end
		return true, true
	end
	)
	
	Decisions_ArvisRottenritter.DoFunc = (
	function(pPlayer)
		local iTurns = math.ceil(25 * iGAMod)
		--local iReward = math.ceil(300*iMod)
		--pPlayer:ChangeJONSCulture(-iCost)
		pPlayer:ChangeNumResourceTotal(iMagistrate, -3)
		pPlayer:ChangeGoldenAgeTurns(iTurns)
		pPlayer:GetCapitalCity():SetNumRealBuilding(GameInfoTypes.BUILDING_ARVIS_DUMMY4, 1)
		for pCity in pPlayer:Cities() do
			pCity:ChangePopulation(-1, true)
		end
		save(pPlayer, "Decisions_ArvisRottenritter", true)
	end
	)
	
Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_MH_VELTHOMER, "Decisions_ArvisRottenritter", Decisions_ArvisRottenritter)
--------------------------------------------------------------------------------------------------------------------------
-- Arvis: Appoint the DAHK Bishops
--------------------------------------------------------------------------------------------------------------------------
local Decisions_ArvisLoptyrBishops = {}
	Decisions_ArvisLoptyrBishops.Name = "TXT_KEY_DECISIONS_ARVIS_BISHOPS"
	Decisions_ArvisLoptyrBishops.Desc = "TXT_KEY_DECISIONS_ARVIS_BISHOPS_DESC"
	HookDecisionCivilizationIcon(Decisions_ArvisLoptyrBishops, "CIVILIZATION_MH_VELTHOMER")
	Decisions_ArvisLoptyrBishops.CanFunc = (
	function(pPlayer)
		if (pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_MH_VELTHOMER) then
			return false, false
		end
		if load(pPlayer, "Decisions_ArvisLoptyrBishops") == true then
		Decisions_ArvisLoptyrBishops.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_ARVIS_BISHOPS_ENACTED_DESC")
			return false, false, true
		end
		
		local iCost = math.ceil(pPlayer:GetTotalPopulation() * 5 * iMod)
		local iReward = math.ceil(pPlayer:GetTotalPopulation() * 10 * iMod)
		local iReligion = GetPlayerMajorityReligion(pPlayer)
		Decisions_ArvisLoptyrBishops.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_ARVIS_BISHOPS_DESC", iCost, iReward)
		if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 1) then return true, false end
		if pPlayer:GetCurrentEra() < GameInfoTypes.ERA_MEDIEVAL then return true, false end		
		
		if (pPlayer:GetGold() >= iCost) and (iReligion ~= nil) then
			return true, true
		else
			return true, false
		end
	end
	)
	
	Decisions_ArvisLoptyrBishops.DoFunc = (
	function(pPlayer)
		local iCost = math.ceil(pPlayer:GetTotalPopulation() * 5 * iMod)
		local iReward = math.ceil(pPlayer:GetTotalPopulation() * 10 * iMod)
		pPlayer:ChangeNumResourceTotal(iMagistrate, -1)
		pPlayer:ChangeGold(-iCost)
		pPlayer:ChangeJONSCulture(iReward)
		
		local iReligion = GetPlayerMajorityReligion(pPlayer)
		for pCity in pPlayer:Cities() do
		for row in GameInfo.Religions() do
				local iLoopReligion = row.ID
				if (iLoopReligion ~= GameInfo.Religions.RELIGION_PANTHEON.ID and iLoopReligion ~= iReligion) then
					pCity:ConvertPercentFollowers(-1, iLoopReligion, 100)
				end
			end
		end
		
		save(pPlayer, "Decisions_ArvisLoptyrBishops", true)
	end
	)
	
Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_MH_VELTHOMER, "Decisions_ArvisLoptyrBishops", Decisions_ArvisLoptyrBishops)
--------------------------------------------------------------------------------------------------------------------------
-- Sigurd: Seek Protecc from Grannvale
--------------------------------------------------------------------------------------------------------------------------
local Decisions_SigurdGrannvaleProtec = {}
    Decisions_SigurdGrannvaleProtec.Name = "TXT_KEY_DECISIONS_SIGURD_GRANNVALE"
	Decisions_SigurdGrannvaleProtec.Desc = "TXT_KEY_DECISIONS_SIGURD_GRANNVALE_DESC"
	HookDecisionCivilizationIcon(Decisions_SigurdGrannvaleProtec, "CIVILIZATION_SIGURD_CHALPHY")
	Decisions_SigurdGrannvaleProtec.CanFunc = (
	function(pPlayer)
		if pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_SIGURD_CHALPHY then return false, false end
		if load(pPlayer, "Decisions_SigurdGrannvaleProtec") == true then
			Decisions_SigurdGrannvaleProtec.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_SIGURD_GRANNVALE_ENACTED_DESC")
			return false, false, true
		end
		
		local iCost = math.ceil(500 * iMod)
		Decisions_SigurdGrannvaleProtec.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_SIGURD_GRANNVALE_DESC", iCost)
		if (pPlayer:GetGold() < iCost) then return true, false end
		if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 2) then return true, false end
		if pPlayer:GetCurrentEra() > GameInfoTypes.ERA_RENAISSANCE then return true, false end
		
		return true, true
	end
	)
	
	Decisions_SigurdGrannvaleProtec.DoFunc = (
	function(pPlayer)
		local iCost = math.ceil(500 * iMod)
		pPlayer:ChangeGold(-iCost)
		pPlayer:ChangeNumResourceTotal(iMagistrate, -2)
		pPlayer:GetCapitalCity():SetNumRealBuilding(GameInfoTypes.BUILDING_DECISIONS_SIGURD_1, 1)
		save(pPlayer, "Decisions_SigurdGrannvaleProtec", true)
	end
	)
	
Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_SIGURD_CHALPHY, "Decisions_SigurdGrannvaleProtec", Decisions_SigurdGrannvaleProtec)

--------------------------------------------------------------------------------------------------------------------------
-- Sigurd: Engage in a Holy Crusade
--------------------------------------------------------------------------------------------------------------------------
local Decisions_SigurdHolyWar = {}
	Decisions_SigurdHolyWar.Name = "TXT_KEY_DECISIONS_SIGURD_CRUSADE"
	Decisions_SigurdHolyWar.Desc = "TXT_KEY_DECISIONS_SIGURD_CRUSADE_DESC"
	HookDecisionCivilizationIcon(Decisions_SigurdHolyWar, "CIVILIZATION_SIGURD_CHALPHY")
	Decisions_SigurdHolyWar.CanFunc = (
	function(pPlayer)
		if (pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_SIGURD_CHALPHY) then
			return false, false
		end
		
		local iEra = load(pPlayer, "Decisions_SigurdHolyWar")
		local iCurrentEra = pPlayer:GetCurrentEra()
		if iEra ~= nil then
			if iEra < iCurrentEra then
				save(pPlayer, "Decisions_SigurdHolyWar", nil)
			else
				Decisions_SigurdHolyWar.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_SIGURD_CRUSADE_ENACTED_DESC")
				return false, false, true
			end
		end
		
		local iCost = math.ceil((iCurrentEra + 1) * 100 * iMod)
		Decisions_SigurdHolyWar.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_SIGURD_CRUSADE_DESC", iCost)

		if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 1) then return true, false end
		if (pPlayer:GetFaith() < iCost) then return true, false end
		if (Teams[pPlayer:GetTeam()]:GetAtWarCount(false)) < 1 then return true, false end
			
return true, true
end
	)
	
	Decisions_SigurdHolyWar.DoFunc = (
	function(pPlayer)
		pPlayer:ChangeNumResourceTotal(iMagistrate, -1)
		
		local iCost = math.ceil((pPlayer:GetCurrentEra() + 1) * 100 * iMod)
		pPlayer:ChangeFaith(-iCost)
		pPlayer:SetNumFreePolicies(1)
		pPlayer:SetNumFreePolicies(0)
		pPlayer:SetHasPolicy(GameInfoTypes.POLICY_DECISIONS_SIGURD, true)
		pPlayer:GetCapitalCity():SetNumRealBuilding(GameInfoTypes.BUILDING_DECISIONS_SIGURD_2, 1)		
		save(pPlayer, "Decisions_SigurdHolyWar", pPlayer:GetCurrentEra())
	end
	)
	
Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_SIGURD_CHALPHY, "Decisions_SigurdHolyWar", Decisions_SigurdHolyWar)