--=======================================================================================================================
-- Bingle's Civ IV Traits
--=======================================================================================================================
-- Leader_SharedTraits
------------------------------	
CREATE TABLE IF NOT EXISTS 
    Leader_SharedTraits (
    LeaderType          text    REFERENCES Leaders(Type)        default null,
    TraitOne            text    REFERENCES Policies(Type)       default null,
    TraitTwo            text    REFERENCES Policies(Type)       default null);
     
INSERT OR REPLACE INTO Leader_SharedTraits
            (LeaderType,		TraitOne,		          TraitTwo)
VALUES      ('LEADER_SIGURD',	'POLICY_PROTECTIVE_X',	  'POLICY_CHARISMATIC_X'),
			('LEADER_MH_ARVIS',	'POLICY_IMPERIALISTIC_X', 'POLICY_INVENTIVE_X');

UPDATE Leaders 
SET Description = (CASE WHEN EXISTS(SELECT Type FROM Policies WHERE Type = 'POLICY_PHILOSOPHICAL_X' )
	THEN 'TXT_KEY_LEADER_SIGURD_CIV_IV'
	ELSE 'TXT_KEY_LEADER_SIGURD' END) 
WHERE Type = 'LEADER_SIGURD';

UPDATE Leaders 
SET Description = (CASE WHEN EXISTS(SELECT Type FROM Policies WHERE Type = 'POLICY_PHILOSOPHICAL_X' )
	THEN 'TXT_KEY_LEADER_MH_ARVIS_CIV_IV'
	ELSE 'TXT_KEY_LEADER_MH_ARVIS' END) 
WHERE Type = 'LEADER_MH_ARVIS';
--==========================================================================================================================
-- SUKRITACT DECISIONS
--==========================================================================================================================
-- DecisionsAddin_Support
------------------------------
CREATE TABLE IF NOT EXISTS DecisionsAddin_Support(FileName);
INSERT INTO DecisionsAddin_Support (FileName) VALUES ('ArvSigDecisions.lua');
--==========================================================================================================================
-- Civilizations_YnAEMP
--------------------------------------------------------------------------------------------------------------------------

CREATE TABLE IF NOT EXISTS Civilizations_YnAEMP(CivilizationType, MapPrefix, X, Y, CapitalName, AltX, AltY, AltCapitalName);
INSERT INTO Civilizations_YnAEMP
		(CivilizationType,			    MapPrefix,				X,		Y,		AltX,	AltY,	AltCapitalName)
VALUES	('CIVILIZATION_SIGURD_CHALPHY',	'FireEmblemJugdral',	37,		18,		23,	    16,	    'Granbell'),
		('CIVILIZATION_MH_VELTHOMER',	'FireEmblemJugdral',	45,		31,		null,	null,	null);
--------------------------------------------------------------------------------------------------------------------------
-- Civilizations_YnAEMPRequestedResources
--------------------------------------------------------------------------------------------------------------------------
CREATE TABLE IF NOT EXISTS Civilizations_YnAEMPRequestedResources(CivilizationType, MapPrefix, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4, Req5, Yield5, Req6, Yield6);

INSERT INTO Civilizations_YnAEMPRequestedResources
		(CivilizationType,			      MapPrefix,				Req1,				Yield1,	 Req2,				Yield2,		Req3,				Yield3,		Req4,	Yield4,		Req5,	Yield5,		Req6,	Yield6)
VALUES  ('CIVILIZATION_SIGURD_CHALPHY',	  'FireEmblemJugdral',		'RESOURCE_COPPER',	1,		 'RESOURCE_SALT',	1,			'RESOURCE_STONE',	1,			null,	0,			null,	0,			null,	0),
		('CIVILIZATION_MH_VELTHOMER',     'FireEmblemJugdral',		'RESOURCE_MARBLE',	1,		 'RESOURCE_SILVER',	1,			'RESOURCE_WINE',	1,			null,	0,			null,	0,			null,	0);
		--==========================================================================================================================
--==========================================================================================================================
-- Civilizations_YnAEMP
--------------------------------------------------------------------------------------------------------------------------

CREATE TABLE IF NOT EXISTS Civilizations_YnAEMP(CivilizationType, MapPrefix, X, Y, CapitalName, AltX, AltY, AltCapitalName);
INSERT INTO Civilizations_YnAEMP
		(CivilizationType,			    MapPrefix,				X,		Y,		AltX,	AltY,	AltCapitalName)
VALUES	('CIVILIZATION_SIGURD_CHALPHY',	'FireEmblemJugdral',	37,		18,		null,	null,	null),
		('CIVILIZATION_MH_VELTHOMER',	'FireEmblemJugdral',	45,		31,		null,	null,	null);
--------------------------------------------------------------------------------------------------------------------------
-- Civilizations_YnAEMPRequestedResources
--------------------------------------------------------------------------------------------------------------------------
CREATE TABLE IF NOT EXISTS Civilizations_YnAEMPRequestedResources(CivilizationType, MapPrefix, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4, Req5, Yield5, Req6, Yield6);

INSERT INTO Civilizations_YnAEMPRequestedResources
		(CivilizationType,			      MapPrefix,				Req1,				Yield1,	 Req2,				Yield2,		Req3,				Yield3,		Req4,	Yield4,		Req5,	Yield5,		Req6,	Yield6)
VALUES  ('CIVILIZATION_SIGURD_CHALPHY',	  'FireEmblemJugdral',		'RESOURCE_COPPER',	1,		 'RESOURCE_SALT',	1,			'RESOURCE_STONE',	1,			null,	0,			null,	0,			null,	0),
		('CIVILIZATION_MH_VELTHOMER',     'FireEmblemJugdral',		'RESOURCE_MARBLE',	1,		 'RESOURCE_SILVER',	1,			'RESOURCE_WINE',	1,			null,	0,			null,	0,			null,	0);
--------------------------------------------------------------------------------------------------------------------------
-- Fire Emblem Religions
--------------------------------------------------------------------------------------------------------------------------
UPDATE Civilization_Religions 
SET ReligionType = 'RELIGION_EDDA'
WHERE CivilizationType = 'CIVILIZATION_SIGURD_CHALPHY' AND EXISTS (SELECT 1 FROM Units WHERE Type = 'UNIT_KFER_CLERIC');

UPDATE Civilization_Religions 
SET ReligionType = 'RELIGION_MAERA'
WHERE CivilizationType = 'CIVILIZATION_MH_VELTHOMER' AND EXISTS (SELECT 1 FROM Units WHERE Type = 'UNIT_KFER_CLERIC');

