-- ArvisUA
-- Author: TheMH06
-- DateCreated: 5/3/2018 10:54:15 PM
--------------------------------------------------------------
-- JFD_IsCivilisationActive
--------------------------------------------------------------
function JFD_IsCivilisationActive(civilisationID)
	for iSlot = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		local slotStatus = PreGame.GetSlotStatus(iSlot)
		if (slotStatus == SlotStatus["SS_TAKEN"] or slotStatus == SlotStatus["SS_COMPUTER"]) then
			if PreGame.GetCivilization(iSlot) == civilisationID then
				return true
			end
		end
	end

	return false
end
--------------------------------------------------------------
local civilisationID		= GameInfoTypes["CIVILIZATION_MH_VELTHOMER"]
local isMHArvisActive	= JFD_IsCivilisationActive(civilisationID)

	local iArvis = GameInfoTypes.CIVILIZATION_MH_VELTHOMER
	local iArvisTechDummy = GameInfoTypes["BUILDING_ARVIS_DUMMY1"]
	local iArvisGADummy = GameInfoTypes["BUILDING_ARVIS_DUMMY2"]
	local iArvisCourt = GameInfoTypes["BUILDING_ARVIS_COURT"]
	local iCourtDummy = GameInfoTypes["BUILDING_ARVIS_DUMMY3"]
	local iCourtDummy2 = GameInfoTypes["BUILDING_ARVIS_DUMMY3"]

-------------------------------------------------------------------------------------------------------------------------
-- Arvis UA: Get Happiness from Techs Researched during Golden Ages.
-------------------------------------------------------------------------------------------------------------------------
function ArvisGoldenAgeTech(iTeam, iTech, bAdopted)
	for iPlayer=0, GameDefines.MAX_MAJOR_CIVS-1 do
		local player = Players[iPlayer]
		local bTeam = (player:GetTeam() == iTeam)
		local bVelthomer = (player:GetCivilizationType() == iArvis)
		local pCapital = player:GetCapitalCity()
			
		if bTeam and bVelthomer and bAdopted and (player:IsGoldenAge()) then
		pCapital:SetNumRealBuilding(iArvisTechDummy, pCapital:GetNumBuilding(iArvisTechDummy) + 1)
		end
	end
end

if isMHArvisActive then
GameEvents.TeamSetHasTech.Add(ArvisGoldenAgeTech)
end

-------------------------------------------------------------------------------------------------------------------------
-- Arvis UA: GA Points from Occupied Cities.
-------------------------------------------------------------------------------------------------------------------------
function ArvisOccupiedGA(playerID)
	local player = Players[playerID]
	-- C15 --
	if player:IsGoldenAge() then return end
	-- /C15 --
	for city in player:Cities() do
		if (city:GetNumBuilding(iArvisGADummy) > 0) then
			player:ChangeGoldenAgeProgressMeter(15)
		end
	end
end

if isMHArvisActive then
GameEvents.PlayerDoTurn.Add(ArvisOccupiedGA)
end

-------------------------------------------------------------------------------------------------------------------------
-- Emblem Court: +50% Science Boost if built in a conquered city.
-------------------------------------------------------------------------------------------------------------------------
function ArvisCourtAbility(playerID)
	local player = Players[playerID];
	if player:GetCivilizationType() == iArvis then
		for pCity in player:Cities() do
			if (pCity:GetNumBuilding(iArvisGADummy) > 0) and (pCity:GetNumBuilding(iArvisCourt) > 0) then
				 pCity:SetNumRealBuilding(iCourtDummy, 1)
			else
				pCity:SetNumRealBuilding(iCourtDummy, 0)
			end	
		end
	end
end

if isMHArvisActive then
GameEvents.PlayerDoTurn.Add(ArvisCourtAbility)
end

-- C15 --
function C15_Arvis_CityConstructed(playerID, cityID, iBuilding)
	local pCity = pPlayer:GetCityByID(cityID)
	if iBuilding == iArvisCourt then
		if pCity:IsHasBuilding(iArvisGADummy) then
			pCity:SetNumRealBuilding(iCourtDummy, 1)
		else
			pCity:SetNumRealBuilding(iCourtDummy, 0)
		end
	end
end

if isMHArvisActive then
GameEvents.CityConstructed.Add(C15_Arvis_CityConstructed)
end
-- /C15 --