-- SigurdUA2
-- Author: TheMH06
-- DateCreated: 5/20/2018 8:06:37 PM
--------------------------------------------------------------
include("PlotIterators.lua");
--------------------------------------------------------------
-- JFD_IsCivilisationActive
--------------------------------------------------------------
function JFD_IsCivilisationActive(civilisationID)
	for iSlot = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		local slotStatus = PreGame.GetSlotStatus(iSlot)
		if (slotStatus == SlotStatus["SS_TAKEN"] or slotStatus == SlotStatus["SS_COMPUTER"]) then
			if PreGame.GetCivilization(iSlot) == civilisationID then
				return true
			end
		end
	end

	return false
end
-------------------------------------------------------------------------------------------------------------------------
local civilisationID		= GameInfoTypes["CIVILIZATION_SIGURD_CHALPHY"]
local isMHSigurdActive	= JFD_IsCivilisationActive(civilisationID)
-------------------------------------------------------------------------------------------------------------------------
-- Sigurd UA #2: Promotion for each Dummy/new Tech, up to 5
-------------------------------------------------------------------------------------------------------------------------
local iSigurdTechDummy = GameInfoTypes["BUILDING_SIGURD_TECH_DUMMY"]
local iSigurdPromo1 = GameInfoTypes["PROMOTION_SIGURD_TECH_1"]
local iSigurdPromo2 = GameInfoTypes["PROMOTION_SIGURD_TECH_2"]
local iSigurdPromo3 = GameInfoTypes["PROMOTION_SIGURD_TECH_3"]
local iSigurdPromo4 = GameInfoTypes["PROMOTION_SIGURD_TECH_4"]
local iSigurdPromo5 = GameInfoTypes["PROMOTION_SIGURD_TECH_5"]

function SigurdTechPromotions(playerID)
	local player = Players[playerID]
	if player:GetCivilizationType() == iSigurdCiv then
		local pCapital = player:GetCapitalCity()
		print("YER DUMMIES: " ..pCapital:GetNumBuilding(iSigurdTechDummy))
		for pUnit in player:Units() do
			if (pCapital:GetNumBuilding(iSigurdTechDummy) == 0) then
				pUnit:SetHasPromotion(iSigurdPromo1, false);
				pUnit:SetHasPromotion(iSigurdPromo2, false);
				pUnit:SetHasPromotion(iSigurdPromo3, false);
				pUnit:SetHasPromotion(iSigurdPromo4, false);
				pUnit:SetHasPromotion(iSigurdPromo5, false);
			elseif (pCapital:GetNumBuilding(iSigurdTechDummy) == 2) then
				pUnit:SetHasPromotion(iSigurdPromo1, true);
				pUnit:SetHasPromotion(iSigurdPromo2, false);
				pUnit:SetHasPromotion(iSigurdPromo3, false);
				pUnit:SetHasPromotion(iSigurdPromo4, false);
				pUnit:SetHasPromotion(iSigurdPromo5, false);
			elseif (pCapital:GetNumBuilding(iSigurdTechDummy) == 4) then
				pUnit:SetHasPromotion(iSigurdPromo1, true);
				pUnit:SetHasPromotion(iSigurdPromo2, true);
				pUnit:SetHasPromotion(iSigurdPromo3, false);
				pUnit:SetHasPromotion(iSigurdPromo4, false);
				pUnit:SetHasPromotion(iSigurdPromo5, false);
			elseif (pCapital:GetNumBuilding(iSigurdTechDummy) == 6) then
				pUnit:SetHasPromotion(iSigurdPromo1, true);
				pUnit:SetHasPromotion(iSigurdPromo2, true);
				pUnit:SetHasPromotion(iSigurdPromo3, true);
				pUnit:SetHasPromotion(iSigurdPromo4, false);
				pUnit:SetHasPromotion(iSigurdPromo5, false);
			elseif (pCapital:GetNumBuilding(iSigurdTechDummy) == 8) then
				pUnit:SetHasPromotion(iSigurdPromo1, true);
				pUnit:SetHasPromotion(iSigurdPromo2, true);
				pUnit:SetHasPromotion(iSigurdPromo3, true);
				pUnit:SetHasPromotion(iSigurdPromo4, true);
				pUnit:SetHasPromotion(iSigurdPromo5, false);
			elseif (pCapital:GetNumBuilding(iSigurdTechDummy) > 8) then
				pUnit:SetHasPromotion(iSigurdPromo1, true);
				pUnit:SetHasPromotion(iSigurdPromo2, true);
				pUnit:SetHasPromotion(iSigurdPromo3, true);
				pUnit:SetHasPromotion(iSigurdPromo4, true);
				pUnit:SetHasPromotion(iSigurdPromo5, true);
				end
			end
		end
	end

if isMHSigurdActive then
GameEvents.PlayerDoTurn.Add(SigurdTechPromotions)
end
-------------------------------------------------------------------------------------------------------------------------
-- Sigurd UA #1: Dummy for each tech unlocked during wartime.
-------------------------------------------------------------------------------------------------------------------------
function SigurdTechBuilding(iTeam, iTech, bAdopted)
	for iPlayer=0, GameDefines.MAX_MAJOR_CIVS-1 do
		local player = Players[iPlayer]
		local bTeam = (player:GetTeam() == iTeam)
		local bChalphy = (player:GetCivilizationType() == iSigurdCiv)
		local pCapital = player:GetCapitalCity()
			
		if bTeam and bChalphy and bAdopted then
		if Teams[player:GetTeam()]:GetAtWarCount(true) > 0 then
		pCapital:SetNumRealBuilding(iSigurdTechDummy, pCapital:GetNumBuilding(iSigurdTechDummy) + 1)
			end
		end
	end
end

if isMHSigurdActive then
GameEvents.TeamSetHasTech.Add(SigurdTechBuilding)
end
--------------------------------------------------------------
-- Sigurd UA #3: Removes 'Tech' iSigurdHolyPromotions upon making Peace.
-----------------------------------------------------------------
local iSigurdDecisionDummy = GameInfoTypes["BUILDING_DECISIONS_SIGURD_2"]

function SigurdMakePeace(playerID)
	local player = Players[playerID]
	if player:GetCivilizationType() == iSigurdCiv then
	local pCapital = player:GetCapitalCity()
	      pCapital:SetNumRealBuilding(iSigurdTechDummy, 0)
		  pCapital:SetNumRealBuilding(iSigurdDecisionDummy, 0)

	end
end

if isMHSigurdActive then
GameEvents.MakePeace.Add(SigurdMakePeace)
end
--------------------------------------------------------------
-- Sigurd UA #4/1: Captured cities are purged of their religions.
-----------------------------------------------------------------
function SigurdCaptureCity1(oldPlayerID, capital, iX, iY, newPlayerID)
	local player = Players[newPlayerID]
	if player:GetCivilizationType() == iSigurdCiv then 
		if player:GetReligionCreatedByPlayer() > 0 or player:GetCapitalCity():GetReligiousMajority() > 0 then
			local religionID = player:GetReligionCreatedByPlayer() or player:GetCapitalCity():GetReligiousMajority()
			local city = Map.GetPlot(iX, iY):GetPlotCity()
			city:AdoptReligionFully(religionID)
		end
	end
end

if isMHSigurdActive then
GameEvents.CityCaptureComplete.Add(SigurdCaptureCity1)
end
----------------------------------------------------------------
-- Sigurd UA #4/2: Boost science when capturing cities.
-----------------------------------------------------------------
function SigurdCaptureCity2(oldOwnerID, capital, cityX, cityY, newOwnerID)
	local player = Players[newOwnerID]
	local iTech = player:GetCurrentResearch()
	local iReward = math.ceil(0.4 * player:GetResearchCost(iTech))

	if (player:IsAlive() and player:GetCivilizationType() == iSigurdCiv) then
		local pTeamTech = Teams[player:GetTeam()]:GetTeamTechs()
		if (CurrentTech > -1) then
		pTeamTech:ChangeResearchProgress(iTech, iReward, newOwnerID)
		end
	end
end

if isMHSigurdActive then
GameEvents.CityCaptureComplete.Add(SigurdCaptureCity2)
end
----------------------------------------------------------------
-- Sigurd UB: Generates Science while at war. How neato!
-----------------------------------------------------------------
function SigurdHomeCastle(playerID)
	local player = Players[playerID]
	if player:GetCivilizationType() == iSigurdCiv then
		for pCity in player:Cities() do
			if pCity:IsHasBuilding(GameInfoTypes["BUILDING_SIGURD_HOMECASTLE"]) then
				if player:IsAtWar() then 
					player:GetCapitalCity():SetNumRealBuilding(GameInfoTypes.BUILDING_SIGURD_HOMECASTLE_WAR, 1)
				else
					player:GetCapitalCity():SetNumRealBuilding(GameInfoTypes.BUILDING_SIGURD_HOMECASTLE_WAR, 0)
				end
			end
		end
	end
end

if isMHSigurdActive then
GameEvents.PlayerDoTurn.Add(SigurdHomeCastle)
end
-----------------------------------------------------------------
-- Sigurd Decision: Remove 'Holy Morale' Promotion with Peace
-----------------------------------------------------------------
 local iSigurdDecisionPromotion = GameInfoTypes.PROMOTION_DECISION_SIGURD

function SigurdDecisionPeace(iTeam, jTeam, war)
    for iPlayer = 0, GameDefines.MAX_CIV_PLAYERS-1, 1 do
        player = Players[iPlayer]
        if not war and (player:GetTeam() == iTeam or player:GetTeam() == jTeam) then
            if player:GetCivilizationType() == iSigurdCiv then
                for unit in player:Units() do
                        unit:SetHasPromotion(iSigurdDecisionPromotion, false)
                    end
                end
            end
        end
    end
if isMHSigurdActive then
Events.WarStateChanged.Add(SigurdDecisionPeace)
end

function SigurdDecisionPeace2(iTeam, jTeam, war)
    for iPlayer = 0, GameDefines.MAX_CIV_PLAYERS-1, 1 do
        player = Players[iPlayer]
        if not war and (player:GetTeam() == iTeam or player:GetTeam() == jTeam) then
            if player:GetCivilizationType() == iSigurdCiv then
			if player:HasPolicy(GameInfoTypes["POLICY_DECISIONS_SIGURD"]) then
				player:SetHasPolicy(GameInfoTypes["POLICY_DECISIONS_SIGURD"], false)
                    end
                end
            end
        end
    end
if isMHSigurdActive then
Events.WarStateChanged.Add(SigurdDecisionPeace2)
end
-----------------------------------------------------------------
-- Sigurd Home Castle: Bonus to units garrisoned.
-----------------------------------------------------------------
function SigurdHomeCastle(iPlayer)
local pPlayer = Players[iPlayer];
for pUnit in pPlayer:Units() do
	pUnit:SetHasPromotion(GameInfoTypes.PROMOTION_SIGURD_GARRISON, false);
	local pPlot = pUnit:GetPlot()
	if pPlot:IsCity() then
		local pCity = pPlot:GetPlotCity()
		if pCity:IsHasBuilding(GameInfoTypes.BUILDING_SIGURD_HOMECASTLE) then
				pUnit:SetHasPromotion(GameInfoTypes.PROMOTION_SIGURD_GARRISON, true);
			end
		end
	end
end

if isMHSigurdActive then
GameEvents.PlayerDoTurn.Add(SigurdHomeCastle)
end